scala.tools.nsc.backend.icode.analysis.TypeFlowAnalysis

# MethodTFA

#### class MethodTFA extends DataFlowAnalysis[typeFlowLattice.type]

Source
  TypeFlowAnalysis.scala

Linear Supertypes
DataFlowAnalysis[typeFlowLattice.type], AnyRef, Any
Known Subclasses
MTFAGrowable
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. MethodTFA
2. DataFlowAnalysis
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new MethodTFA(m: Global.icodes.IMethod)

2. #### new MethodTFA()

### Type Members

1. #### case class Bind(l: Global.icodes.Local, t: InferredType) extends Gen with Product with Serializable

2. #### case class Const(t: Global.icodes.TypeKind) extends InferredType with Product with Serializable

   A type that does not depend on input to the transfer function.

3. #### abstract class Gen extends AnyRef

4. #### abstract class InferredType extends AnyRef

5. #### type P = Global.icodes.BasicBlock

   A type for program points.

   A type for program points.

   Definition Classes
     MethodTFA → DataFlowAnalysis

6. #### case class Push(t: InferredType) extends Gen with Product with Serializable

7. #### class TransferFunction extends (Elem) ⇒ Elem

   A flow transfer function of a basic block.

8. #### case class TypeOfStackPos(n: Int) extends InferredType with Product with Serializable

   The type found at a stack position.

9. #### case class TypeOfVar(l: Global.icodes.Local) extends InferredType with Product with Serializable

   The type of a given local variable.

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from MethodTFA to any2stringadd[MethodTFA] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (MethodTFA, B)

   Implicit information
     This member is added by an implicit conversion from MethodTFA to ArrowAssoc[MethodTFA] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### val STRING: Global.icodes.REFERENCE

7. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

8. #### def backwardAnalysis(f: (P, Elem) ⇒ Elem): Unit

   Definition Classes
     DataFlowAnalysis

9. #### def blockTransfer(b: Global.icodes.BasicBlock, in: Elem): Elem

10. #### def clone(): AnyRef

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

11. #### def ensuring(cond: (MethodTFA) ⇒ Boolean, msg: ⇒ Any): MethodTFA

    Implicit information
      This member is added by an implicit conversion from MethodTFA to Ensuring[MethodTFA] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: (MethodTFA) ⇒ Boolean): MethodTFA

    Implicit information
      This member is added by an implicit conversion from MethodTFA to Ensuring[MethodTFA] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean, msg: ⇒ Any): MethodTFA

    Implicit information
      This member is added by an implicit conversion from MethodTFA to Ensuring[MethodTFA] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: Boolean): MethodTFA

    Implicit information
      This member is added by an implicit conversion from MethodTFA to Ensuring[MethodTFA] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

16. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

17. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

18. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from MethodTFA to StringFormat[MethodTFA] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

19. #### def forwardAnalysis(f: (P, Elem) ⇒ Elem): Unit

    Implements forward dataflow analysis: the transfer function is applied when inputs to a Program point change, to obtain the new output value.

    Implements forward dataflow analysis: the transfer function is applied when inputs to a Program point change, to obtain the new output value.

    f

      the transfer function.

    Definition Classes
      DataFlowAnalysis

20. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

21. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

22. #### val in: Map[P, Elem]

    Definition Classes
      DataFlowAnalysis

23. #### def init(m: Global.icodes.IMethod): Unit

    Initialize the in/out maps for the analysis of the given method.

24. #### def init(f: ⇒ Unit): Unit

    Definition Classes
      DataFlowAnalysis

25. #### def interpret(in: Elem, i: Global.icodes.Instruction): Elem

    Abstract interpretation for one instruction.

26. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

27. #### var iterations: Int

    the number of times we iterated before reaching a fixpoint.

    the number of times we iterated before reaching a fixpoint.

    Definition Classes
      DataFlowAnalysis

28. #### val lattice: typeFlowLattice.type

    Definition Classes
      MethodTFA → DataFlowAnalysis

29. #### var method: Global.icodes.IMethod

30. #### def mutatingInterpret(out: Elem, i: Global.icodes.Instruction): Elem

31. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

32. #### final def notify(): Unit

    Definition Classes
      AnyRef

33. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

34. #### val out: Map[P, Elem]

    Definition Classes
      DataFlowAnalysis

35. #### def run(): Unit

    Definition Classes
      MethodTFA → DataFlowAnalysis

36. #### var stat: Boolean

    collect statistics?

    collect statistics?

    Definition Classes
      DataFlowAnalysis

37. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

38. #### def toString(): String

    Definition Classes
      AnyRef → Any

39. #### val visited: HashSet[P]

    Definition Classes
      DataFlowAnalysis

40. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

41. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

42. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

43. #### val worklist: Set[P]

    Definition Classes
      DataFlowAnalysis

44. #### def →[B](y: B): (MethodTFA, B)

    Implicit information
      This member is added by an implicit conversion from MethodTFA to ArrowAssoc[MethodTFA] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from DataFlowAnalysis[typeFlowLattice.type]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from MethodTFA to any2stringadd[MethodTFA]

### Inherited by implicit conversion StringFormat from MethodTFA to StringFormat[MethodTFA]

### Inherited by implicit conversion Ensuring from MethodTFA to Ensuring[MethodTFA]

### Inherited by implicit conversion ArrowAssoc from MethodTFA to ArrowAssoc[MethodTFA]

### Ungrouped